#region Using

using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;

using Wisej.Web;

using VERISMIC.Localization;
using VERISMIC.Database.PowerManager;
using VERISMIC.PowerManager.Server;
using VERISMIC.PowerManager.Shared;
using VERISMIC.Database.LANDesk;
using System.DirectoryServices;
using VERISMIC.Server.Shared;
using VERISMIC.PowerManager.Server.Managers.Impls;
using Verismic.MiniLibrary;
using HttpServer.Messages;
using NewPortal.GlobalFeatures.Devices;
using NewPortal.Shared;
using Verismic.PowerManager.Server;
using NewPortal.Queries;
using NewPortal.Queries.Sccm;

#endregion

namespace NewPortal.Reporting
{
    public partial class CollectionBrowserold : HostedInputBlade
    {
        public DataClasses1DataContext context;
        private AccessViewTypes ViewType = AccessViewTypes.All;
        private List<TreeNode> NavTreeNodes = new List<TreeNode>();
        private GroupsAndFoldersManager groupsAndFoldersManager;
        private QueriesAndFoldersManager queriesAndFoldersManager;

        public IQueryable<VERISMIC.Database.PowerManager.Computer> computers { get; set; }
        public string Filter
        {
            get
            {
                return this.treeView1.SelectedNode !=null ?  this.treeView1.SelectedNode.FullPath : string.Empty;
            }
        }
        public TreeNode SelectedNode
        {
            get
            {
                return this.treeView1.SelectedNode;
            }
        }

        public CollectionBrowserold(DataClasses1DataContext cx = null)
        {
            InitializeComponent();
            this.Title = CommonResources.ManagementTree;
            
            this.OKCancel = true;
            //this. += UpdateSettings_OnOk;
           // this.OnCancel += UpdateSettings_OnCancel;
        //this.panelOkCancel
            this.context = cx;
            if( this.context == null)
            {
                this.context = Static.context;
            }
            this.context.ClearCache();

            queriesAndFoldersManager = new QueriesAndFoldersManager(CurrentUser.CustomerId, this.context);
            groupsAndFoldersManager = new GroupsAndFoldersManager(this.context);
        }

        private void UpdateSettings_OnCancel(object sender, ContinueEventArgs e)
        {
           // this.DialogResult = Wisej.Web.DialogResult.Cancel;
            this.Close();
        }

        private void UpdateSettings_OnOk(object sender, ContinueEventArgs e)
        {
           // this.DialogResult = Wisej.Web.DialogResult.OK;
            this.Close();
        }

        private void CollectionBrowser_Load(object sender, EventArgs e)
        {            
            if (CanView(AccessViewTypes.GlobalSiteView))
            {
                TreeNode root = new TreeNode(CommonResources.GlobalSiteView);
                root.Tag = new TreeViewTag(TreeViewType.Default);
                root.Nodes.Add("None");
                //root.TreeView.BeforeExpand += new TreeViewCancelEventHandler(this.treeView1_BeforeExpand);
                //root.TreeView.AfterSelect += new TreeViewEventHandler(this.treeView1_AfterSelect);

                this.NavTreeNodes.Add(root);

                root.Expand();
            }

            if (CanView(AccessViewTypes.ActiveDirectory))
            {
                if (context.ActiveDirectories.Where( n => n.CustomerId == CurrentUser.CustomerId ).Count() > 0 || context.ActiveDirectoryFolders.Where( n => n.CustomerId == CurrentUser.CustomerId ).Count() > 0)
                {
                    TreeNode activeDirectories = new TreeNode(CommonResources.ActiveDirectories);
                    activeDirectories.Tag = new TreeViewTag(TreeViewType.GlobalDirectory);
                    //activeDirectories.TreeView.BeforeExpand += new TreeViewCancelEventHandler(this.treeView1_BeforeExpand);
                   // activeDirectories.TreeView.AfterSelect += new TreeViewEventHandler(this.treeView1_AfterSelect);
                    activeDirectories.Nodes.Add("None");
                    activeDirectories.Collapse();

                    this.NavTreeNodes.Add(activeDirectories);
                }
            }

            if (CanView(AccessViewTypes.SystemsManagment))
            {
                if ((from l in context.LANDeskServers
                     where l.Type == (int)ManagementServerTypes.LANDesk && l.CustomerId == CurrentUser.CustomerId
                     select l).Count() > 0)
                {
                    TreeNode activeDirectories = new TreeNode(CommonResources.LANDesk);
                   // activeDirectories.TreeView.BeforeExpand += new TreeViewCancelEventHandler(this.treeView1_BeforeExpand);
                   // activeDirectories.TreeView.AfterSelect += new TreeViewEventHandler(this.treeView1_AfterSelect);
                    activeDirectories.Tag = new TreeViewTag(TreeViewType.GlobalLANDesk);
                    activeDirectories.Nodes.Add("None");
                    activeDirectories.Collapse();
                    this.NavTreeNodes.Add(activeDirectories);
                }

                if ((from l in context.LANDeskServers
                     where l.Type == (int)ManagementServerTypes.SMS && l.CustomerId == CurrentUser.CustomerId
                     select l).Count() > 0)
                {
                    TreeNode activeDirectories = new TreeNode("SMS/SCCM");
                    activeDirectories.Tag = new TreeViewTag(TreeViewType.GlobalSCCM);
                   // activeDirectories.TreeView.BeforeExpand += new TreeViewCancelEventHandler(this.treeView1_BeforeExpand);
                    //activeDirectories.TreeView.AfterSelect += new TreeViewEventHandler(this.treeView1_AfterSelect);
                    activeDirectories.Nodes.Add("None");
                    activeDirectories.Collapse();
                    this.NavTreeNodes.Add(activeDirectories);
                }
            }

            if (CanView(AccessViewTypes.Queries))
            {
                TreeNode tnQueries = new TreeNode(CommonResources.Queries);
               // tnQueries.TreeView.BeforeExpand += new TreeViewCancelEventHandler(this.treeView1_BeforeExpand);
               // tnQueries.TreeView.AfterSelect += new TreeViewEventHandler(this.treeView1_AfterSelect);
                tnQueries.Tag = new TreeViewTag(TreeViewType.GlobalQueries);
                tnQueries.Nodes.Add("None");

                this.NavTreeNodes.Add(tnQueries);
            }

            if (CanView(AccessViewTypes.Makes))
            {
                TreeNode manufacturers = new TreeNode(CommonResources.Manufacturers);
               // manufacturers.TreeView.BeforeExpand += new TreeViewCancelEventHandler(this.treeView1_BeforeExpand);
               // manufacturers.TreeView.AfterSelect += new TreeViewEventHandler(this.treeView1_AfterSelect);
                manufacturers.Tag = new TreeViewTag(TreeViewType.GlobalPowerLevel);
                manufacturers.Nodes.Add("None");

                this.NavTreeNodes.Add(manufacturers);
            }

            if (CanView(AccessViewTypes.Monitors))
            {
                TreeNode monitors = new TreeNode(CommonResources.Monitors);
               // monitors.TreeView.BeforeExpand += new TreeViewCancelEventHandler(this.treeView1_BeforeExpand);
               // monitors.TreeView.AfterSelect += new TreeViewEventHandler(this.treeView1_AfterSelect);
                monitors.Tag = new TreeViewTag(TreeViewType.GlobalMonitors);
                monitors.Nodes.Add("None");

                this.NavTreeNodes.Add(monitors);
            }

            if (CanView(AccessViewTypes.Groups))
            {
                TreeNode groups = new TreeNode(CommonResources.Groups);
                groups.TreeView.BeforeExpand += new TreeViewCancelEventHandler(this.treeView1_BeforeExpand);
              //  groups.TreeView.AfterSelect += new TreeViewEventHandler(this.treeView1_AfterSelect);
                groups.Tag = new TreeViewTag(TreeViewType.Groups);
                groups.Nodes.Add("None");

                this.NavTreeNodes.Add(groups);
            }

            this.treeView1.Nodes.AddRange(this.NavTreeNodes.ToArray());
        }

        public bool CanView(AccessViewTypes type)
        {
            return this.ViewType.HasFlag(type);
        }

        private void treeView1_AfterSelect(object sender, TreeViewEventArgs e)
        {
            if (!CanView(AccessViewTypes.Computers))
                return;

            //this.btnOK.Enabled = true;

            try
            {
                TreeAfterSelect(e);
            }
            catch (Exception ex)
            {
                LogWriter.Instance.Error(ex.ToString());
                MessageBox.Show(ex.Message, ex.Source, MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }

        private void TreeAfterSelect(TreeViewEventArgs e)
        {
            TreeViewTag treeTag = e.Node.Tag as TreeViewTag;

            if (treeTag == null)
                return;

            context.ClearCache();

            computers = (from c in context.Computers
                         where c.CustomerId == CurrentUser.CustomerId
                         select c);

            Location loc = GetLocation(e.Node);
            var chassisType = GetChassisType(e.Node);
            SystemRoles? roleName = GetRole(e.Node);
            Manufacturer manu = GetMake(e.Node);
            Model model = GetModel(e.Node);
            string entryPath = GetDirectoryPath(e.Node);

            switch (treeTag.Type)
            {
                case TreeViewType.Default:
                case TreeViewType.Location:
                case TreeViewType.ByRole:
                case TreeViewType.GlobalByRole:
                case TreeViewType.Manfacturer:
                case TreeViewType.GlobalManufacturer:
                case TreeViewType.Model:
                case TreeViewType.GlobalModel:
                case TreeViewType.ChassisType:
                case TreeViewType.DefaultPathOnly:
                case TreeViewType.MonitorMake:
                case TreeViewType.MonitorModel:
                case TreeViewType.DirectoryEntry:
                case TreeViewType.ActiveDirectory:
                case TreeViewType.MonitorType:
                case TreeViewType.VpmQuery:
                case TreeViewType.SCCMQuery:
                case TreeViewType.GroupsFolder:
                case TreeViewType.Group:
                case TreeViewType.All:
                    {
                        computers = GetComputerQuery(e.Node);
                        computers = (from c in computers
                                     orderby c.DeviceName
                                     select c);
                    }
                    break;
                case TreeViewType.LANDeskFolder:
                case TreeViewType.LANDeskQuery:
                case TreeViewType.LANDeskServer:
                    {
                        computers = GetLANDeskComputers(e.Node);
                        if (computers == null)
                            return;
                        computers = (from c in computers
                                     orderby c.DeviceName
                                     select c);
                    }
                    break;
            }
            return;
        }

        private IQueryable<VERISMIC.Database.PowerManager.Computer> GetComputerQuery(TreeNode node)
        {
            Location loc = GetLocation(node);
            var chassisType = GetChassisType(node);
            SystemRoles? roleName = GetRole(node);
            Manufacturer manu = GetMake(node);
            Model model = GetModel(node);
            string entryPath = GetDirectoryPath(node);
            Group grp = GetGroup(node);
            VERISMIC.Database.PowerManager.Query qry = GetQuery(node);

            var computers = (from c in context.Computers
                             where c.CustomerId == CurrentUser.CustomerId
                             select c);

            TreeViewTag tag = (TreeViewTag)node.Tag;
            switch (tag.Type)
            {
                case TreeViewType.MonitorMake:
                    {
                        MonitorMake make = tag.MonitorMake;
                        computers = (from c in computers
                                     from cm in
                                         (
                                             from m in c.ComputerMonitors
                                             where m.Manufacturer_Idn == make.Make_Idn
                                                && m.Detected
                                             select m.Computer_Idn).Distinct()
                                     where cm == c.Computer_Idn
                                     select c);
                        break;
                    }
                case TreeViewType.MonitorModel:
                    {
                        MonitorModel monModel = tag.MonitorModel;
                        computers = (from c in computers
                                     from cm in
                                         (
                                             from m in c.ComputerMonitors
                                             where m.Model_Idn == monModel.Model_Idn
                                                && m.Detected
                                             select m.Computer_Idn).Distinct()
                                     where cm == c.Computer_Idn
                                     select c);
                        break;
                    }
                case TreeViewType.MonitorType:
                    {
                        MonitorType monType = tag.MonitorType.Value;
                        computers = (from c in computers
                                     from cm in
                                         (
                                            from m in c.ComputerMonitors
                                            where m.MonitorModel.Type == (int)monType
                                                && m.Detected == true
                                            select m.Computer_Idn).Distinct()
                                     where cm == c.Computer_Idn
                                     select c);
                        break;
                    }
            }

            if (grp != null)
            {
                var groupQueries = (from gl in grp.GroupMembers
                                    where gl.Query != null
                                    select gl.Query);

                foreach (var gQry in groupQueries)
                {
                    gQry.UpdateResults(context, CurrentUser.CustomerId);
                }

                computers = (from c in context.Computers
                             join q in context.QueryResults on c.Computer_Idn equals q.Computer_Idn into computersQueries
                             from q in computersQueries.DefaultIfEmpty()
                             from gm in context.GroupMembers
                             from gq in context.Queries
                             from gl in context.Locations
                             where gm.GroupId.Value == grp.ID
                             && (gm.ComputerId.Value == c.Computer_Idn
                                || gm.QueryId.Value == gq.ID && gm.QueryId.Value == q.QueryId
                                || gm.LocationId.Value == gl.Location_Idn && c.Location_Idn == gl.Location_Idn)
                             && c.CustomerId == CurrentUser.CustomerId
                             select c);
            }

            if (loc != null)
            {
                computers = (from c in computers
                             where c.Location.Path == loc.Path || c.Location.Path.EndsWith("\\" + loc.Path)
                             select c);
            }

            if (chassisType != null)
            {
                computers = (from c in computers
                             where c.ChassisType_Idn == (int)chassisType.Value
                             select c);
            }

            if (roleName != null)
            {
                computers = (from c in computers
                             where c.SystemRole_Idn == (int)roleName
                             select c);
            }

            if (manu != null)
            {
                computers = (from c in computers
                             where c.Manufacturer_Idn == manu.Make_Idn
                             select c);
            }

            if (model != null)
            {
                computers = (from c in computers
                             where c.Model_Idn == model.Model_Idn
                             select c);
            }

            if (!string.IsNullOrEmpty(entryPath))
            {
                computers = (from c in computers
                             where c.MachineOU.EndsWith(entryPath)
                             select c);
            }

            if (qry != null)
            {
                qry.UpdateResults(context, CurrentUser.CustomerId);
                computers = (from c in context.Computers
                             from q in context.QueryResults
                             where q.QueryId == tag.VpmQuery.ID && c.Computer_Idn == q.Computer_Idn && c.CustomerId == CurrentUser.CustomerId
                             select c);
            }

            if (tag.SCCMQuery != null)
            {
                var query = new SCCMQuery();
                query.PerformQuery(context, tag.SCCMQuery.ID, CurrentUser.CustomerId);
                computers = (from c in context.Computers
                             from q in context.QueryResults
                             where q.QueryId == tag.SCCMQuery.ID && c.Computer_Idn == q.Computer_Idn && c.CustomerId == CurrentUser.CustomerId
                             select c);
            }

            if (tag.SCCMCollection != null)
            {
                var query = new SCCMCollection();
                query.PerformQuery(context, tag.SCCMCollection.ID, CurrentUser.CustomerId);
                computers = (from c in context.Computers
                             from q in context.QueryResults
                             where q.QueryId == tag.SCCMCollection.ID && c.Computer_Idn == q.Computer_Idn && c.CustomerId == CurrentUser.CustomerId
                             select c);
            }

            return computers;
        }

        private Group GetGroup(TreeNode node)
        {
            return node.Tag is TreeViewTag && ((TreeViewTag)node.Tag).Group != null
                ? groupsAndFoldersManager.GetGroup(((TreeViewTag)node.Tag).Group.ID)
                : null;
        }

        private VERISMIC.Database.PowerManager.Query GetQuery(TreeNode node)
        {
            return node.Tag is TreeViewTag && ((TreeViewTag)node.Tag).VpmQuery != null
                ? queriesAndFoldersManager.GetQuery(((TreeViewTag)node.Tag).VpmQuery.ID)
                : null;
        }

        private IQueryable<VERISMIC.Database.PowerManager.Computer> GetLANDeskComputers(TreeNode node)
        {
            TreeViewTag tag = (TreeViewTag)node.Tag;
            if (tag.Type == TreeViewType.LANDeskFolder)
            {
                if (tag.CustomGroup.Type == 0 && tag.CustomGroup.ParentCustomGroup_Idn == null)
                    return null;
                if (tag.CustomGroup.Type == 1)
                    return null;
            }
            switch (tag.Type)
            {
                case TreeViewType.LANDeskQuery:
                    {

                        var query = new Queries.LANDeskQuery();
                        return query.PerformQuery(context, tag.LdmsQuery.ID, CurrentUser.CustomerId);
                    }
                case TreeViewType.LANDeskFolder:
                    {
                        CustomGroup cg = tag.CustomGroup;

                        IDbConnection conn = cg.Server.NewOpen();
                        IDbCommand cmd = conn.CreateCommand();

                        List<string> deviceIds = new List<string>();
                        string ids = null;
                        cmd.CommandText = "SELECT DeviceID FROM Computer WHERE DeviceID != 'Unassigned' and Computer_Idn in (SELECT Member_Idn FROM CustomGroupComputer WHERE CustomGroup_Idn = " + cg.CustomGroup_Idn + ")";
                        IDataReader reader = cmd.ExecuteReader();
                        while (reader.Read())
                        {
                            if (!Convert.IsDBNull(reader["DeviceID"]))
                            {
                                string deviceId = reader["DeviceID"] as string;
                                deviceId = deviceId.Trim();
                                if (!deviceIds.Contains(deviceId))
                                {
                                    deviceIds.Add(deviceId);
                                    ids += deviceId + ",";
                                }
                            }
                        }
                        reader.Close();
                        conn.Close();

                        if (ids != null)
                            ids = ids.TrimEnd(',');

                        string id = "1_" + cg.CustomGroup_Idn;

                        context.TempLANDesks.DeleteAllOnSubmit(from c in context.TempLANDesks
                                                               where c.Guid == id
                                                               select c);

                        foreach (string deviceID in deviceIds)
                        {
                            TempLANDesk tl = new TempLANDesk();
                            tl.Guid = id;
                            tl.DeviceID = deviceID;
                            context.TempLANDesks.InsertOnSubmit(tl);
                        }

                        context.SubmitChanges();

                        var computers = (from c in context.Computers
                                         from t in context.TempLANDesks
                                         where t.Guid == id && t.DeviceID == c.LANDeskID && c.CustomerId == CurrentUser.CustomerId
                                         select c);
                        return computers;
                    }
                case TreeViewType.LANDeskServer:
                    {
                        IDbConnection conn = tag.LdmsServer.NewOpen();
                        IDbCommand cmd = conn.CreateCommand();

                        List<string> deviceIds = new List<string>();
                        string ids = null;
                        cmd.CommandText = "SELECT DeviceID FROM Computer where DeviceID != 'Unassigned'";
                        IDataReader reader = cmd.ExecuteReader();
                        while (reader.Read())
                        {
                            if (!Convert.IsDBNull(reader["DeviceID"]))
                            {
                                string deviceId = reader["DeviceID"] as string;
                                deviceId = deviceId.Trim();
                                if (!deviceIds.Contains(deviceId))
                                {
                                    deviceIds.Add(deviceId);
                                    ids += deviceId + ",";
                                }
                            }
                        }
                        reader.Close();
                        conn.Close();

                        if (ids != null)
                            ids = ids.TrimEnd(',');

                        string id = "1_" + System.Guid.NewGuid().ToString();

                        context.TempLANDesks.DeleteAllOnSubmit(from c in context.TempLANDesks
                                                               where c.Guid == id
                                                               select c);

                        foreach (string deviceID in deviceIds)
                        {
                            TempLANDesk tl = new TempLANDesk();
                            tl.Guid = id;
                            tl.DeviceID = deviceID;
                            context.TempLANDesks.InsertOnSubmit(tl);
                        }

                        context.SubmitChanges();

                        var computers = (from c in context.Computers
                                         from t in context.TempLANDesks
                                         where t.Guid == id && t.DeviceID == c.LANDeskID && c.CustomerId == CurrentUser.CustomerId
                                         select c);
                        return computers;
                    }
                    break;
            }
            return null;
        }

        public Location GetLocation(TreeNode node)
        {
            if (node.Tag is TreeViewTag)
            {
                TreeViewTag tag = (TreeViewTag)node.Tag;
                if (tag.Location == null && node.Parent != null)
                {
                    return GetLocation(node.Parent);
                }
                else if (tag.Location != null)
                {
                    return (from c in context.Locations
                            where c.Location_Idn == tag.Location.Location_Idn && c.CustomerId == CurrentUser.CustomerId
                            select c).FirstOrDefault();
                }
            }
            return null;
        }

        public VERISMIC.Database.PowerManager.LANDeskQuery GetLandeskQuery(TreeNode node)
        {
            if (node.Tag is TreeViewTag)
            {
                TreeViewTag tag = (TreeViewTag)node.Tag;
                if (tag.LdmsQuery == null && node.Parent != null)
                {
                    return GetLandeskQuery(node.Parent);
                }
                else if (tag.LdmsQuery != null)
                {
                    return (from c in context.LANDeskQueries
                            where c.ID == tag.LdmsQuery.ID
                            select c).FirstOrDefault();
                }
            }
            return null;
        }

        //public VERISMIC.Database.PowerManager.Query GetQuery(TreeNode node)
        //{
        //    if (node.Tag is TreeViewTag)
        //    {
        //        TreeViewTag tag = (TreeViewTag)node.Tag;
        //        if (tag.VpmQuery == null && node.Parent != null)
        //        {
        //            return GetQuery(node.Parent);
        //        }
        //        else if (tag.LdmsQuery != null)
        //        {
        //            return (from c in context.Queries
        //                    where c.ID == tag.VpmQuery.ID && c.CustomerId == UserMgmt.CustomerId
        //                    select c).FirstOrDefault();
        //        }
        //    }
        //    return null;
        //}

        public ChassisTypes? GetChassisType(TreeNode node)
        {
            if (node.Tag is TreeViewTag)
            {
                TreeViewTag tag = (TreeViewTag)node.Tag;
                if (tag.ChassisType == null && node.Parent != null)
                {
                    return GetChassisType(node.Parent);
                }
                else if (tag.ChassisType != null)
                {
                    return tag.ChassisType;
                }
            }
            return null;
        }

        public SystemRoles? GetRole(TreeNode node)
        {
            if (node.Tag is TreeViewTag)
            {
                TreeViewTag tag = (TreeViewTag)node.Tag;
                switch (tag.Type)
                {
                    case TreeViewType.ByRole:
                    case TreeViewType.GlobalByRole:
                        return tag.Role;
                }

                if (node.Parent != null)
                {
                    return GetRole(node.Parent);
                }
            }
            return null;
        }

        public Manufacturer GetMake(TreeNode node)
        {
            if (node.Tag is TreeViewTag)
            {
                TreeViewTag tag = (TreeViewTag)node.Tag;
                switch (tag.Type)
                {
                    case TreeViewType.Manfacturer:
                    case TreeViewType.GlobalManufacturer:
                        return tag.ComputerMake;
                }

                if (node.Parent != null)
                {
                    return GetMake(node.Parent);
                }
            }
            return null;
        }

        public Model GetModel(TreeNode node)
        {
            if (node.Tag is TreeViewTag)
            {
                TreeViewTag tag = (TreeViewTag)node.Tag;
                switch (tag.Type)
                {
                    case TreeViewType.Model:
                    case TreeViewType.GlobalModel:
                        return tag.ComputerModel;
                }

                if (node.Parent != null)
                {
                    return GetModel(node.Parent);
                }
            }
            return null;
        }

        public static string GetDirectoryPath(TreeNode node)
        {
            do
            {
                if (node.Tag is TreeViewTag)
                {
                    TreeViewTag tag = (TreeViewTag)node.Tag;
                    switch (tag.Type)
                    {
                        case TreeViewType.DirectoryEntry:
                        case TreeViewType.ActiveDirectory:
                            {
                                return GetEntryPath(tag);
                            }
                    }
                }
                node = node.Parent;
            }
            while (node != null);
            return null;
        }

        public static string GetEntryPath(TreeViewTag tag)
        {
            if (tag.ADFolder == null && tag.ADServer == null && tag.Entry == null)
                return null;

            if (tag.Entry != null)
                return GetEntryPath(tag.Entry);
            if (tag.ADServer != null)
                return GetEntryPath(tag.ADServer.Entry);
            if (tag.ADFolder != null)
                return GetEntryPath(tag.ADFolder);

            return null;
        }

        public static string GetEntryPath(ActiveDirectoryFolder folder)
        {
            return GetEntryPath(folder.Path);
        }

        public static string GetEntryPath(DirectoryEntry entry)
        {
            if (entry == null)
                return null;

            string path = entry.Path.Substring(7);
            try
            {
                switch (entry.SchemaClassName)
                {
                    case "domainDNS":
                        path = "/" + entry.Name + ",DC=Com";
                        break;
                }
            }
            catch (System.Runtime.InteropServices.COMException ex)
            {
                LogWriter.Instance.Error(ex.ErrorCode + ":" + ex.ToString());
                return null;
            }
            catch (Exception ex)
            {
                LogWriter.Instance.Error(ex.ToString());
                return null;
            }
            return GetEntryPath(path);
        }

        public static string GetEntryPath(string path)
        {
            int start = path.IndexOf('/');
            if (start > -1)
            {
                path = path.Substring(start + 1);
            }
            return path;
        }



        public static DirectoryEntry GetDirectoryEntry(TreeViewTag tag)
        {
            do
            {
                switch (tag.Type)
                {
                    case TreeViewType.DirectoryEntry:
                        return tag.Entry;
                    case TreeViewType.ActiveDirectory:
                        return tag.ADServer.Entry;
                }
                tag = tag.Parent;
            }
            while (tag != null);
            return null;
        }

        private void treeView1_BeforeExpand(object sender, TreeViewCancelEventArgs e)
        {
            if (e.Node.Nodes.Count == 0)
                return;

            if (string.Compare(e.Node.Nodes[0].Text, "None") == 0)
            {
                e.Node.Nodes.Clear();
                TreeViewTag treeTag = (TreeViewTag)e.Node.Tag;
                Location loc = null;
                SystemRoles? role = null;

                var locations = (from l in Static.context.Locations
                                 where l.Parent_Idn == null && l.CustomerId == CurrentUser.CustomerId
                                 orderby l.LocationName
                                 select l);

                if (treeTag == null)
                    return;

                switch (treeTag.Type)
                {
                    case TreeViewType.Default:
                        {
                            foreach (Location location in locations)
                            {
                                TreeNode locNode = e.Node.Nodes.Add(location.LocationName);
                                locNode.TreeView.BeforeExpand += new TreeViewCancelEventHandler(this.treeView1_BeforeExpand);
                                locNode.TreeView.AfterSelect += new TreeViewEventHandler(this.treeView1_AfterSelect);
                                locNode.ImageKey = "folder_16.gif";
                                locNode.SelectedImageKey = "folder_open_16.gif";
                                locNode.Tag = new TreeViewTag(location);
                                locNode.Nodes.Add("None");
                            }
                        }
                        break;
                    case TreeViewType.Location:
                        locations = (from l in context.Locations
                                     where l.Parent_Idn == treeTag.Location.Location_Idn
                                     orderby l.LocationName
                                     select l);

                        foreach (Location location in locations)
                        {
                            TreeNode locNode = e.Node.Nodes.Add(location.LocationName);
                            locNode.TreeView.BeforeExpand += new TreeViewCancelEventHandler(this.treeView1_BeforeExpand);
                            locNode.TreeView.AfterSelect += new TreeViewEventHandler(this.treeView1_AfterSelect);
                            locNode.ImageKey = "folder_16.gif";
                            locNode.SelectedImageKey = "folder_open_16.gif";
                            locNode.Tag = new TreeViewTag(location);
                            locNode.Nodes.Add("None");
                        }
                        BuildTreeRoles(e.Node, treeTag.Location);
                        break;
                    case TreeViewType.ByRole:
                        loc = GetLocation(e.Node);
                        BuildTreeManufacturers(e.Node, treeTag.Role);
                        break;
                    case TreeViewType.Manfacturer:
                        BuildTreeModels(e.Node);
                        break;
                    case TreeViewType.GlobalPowerLevel:
                        BuildTreeRoles(e.Node);
                        break;
                    case TreeViewType.GlobalByRole:
                        BuildTreeManufacturers(e.Node, treeTag.Role);
                        break;
                    case TreeViewType.GlobalManufacturer:
                        role = GetRole(e.Node.Parent);
                        BuildTreeModels(e.Node);
                        break;
                    case TreeViewType.GlobalMonitors:
                        {
                            TreeNode byType = e.Node.Nodes.Add(CommonResources.ByType);
                            byType.TreeView.BeforeExpand += new TreeViewCancelEventHandler(this.treeView1_BeforeExpand);
                            byType.TreeView.AfterSelect += new TreeViewEventHandler(this.treeView1_AfterSelect);
                            byType.ImageKey = "folder_16.gif";
                            byType.SelectedImageKey = "folder_open_16.gif";
                            byType.Tag = new TreeViewTag(TreeViewType.MonitorByType);
                            byType.Nodes.Add("None");

                            foreach (var make in (from m in context.MonitorMakes
                                                  where m.CustomerId == CurrentUser.CustomerId
                                                  select new
                                                  {
                                                      Make = m,
                                                      Num = m.ComputerMonitors.Where(n => n.Detected).Count()
                                                  }).Where(n => n.Num > 0).Select(n => n.Make))
                            {
                                TreeNode monMake = e.Node.Nodes.Add(make.DisplayName);
                                monMake.TreeView.BeforeExpand += new TreeViewCancelEventHandler(this.treeView1_BeforeExpand);
                                monMake.TreeView.AfterSelect += new TreeViewEventHandler(this.treeView1_AfterSelect);
                                monMake.ImageKey = "folder_monitor_closed_16.gif";
                                monMake.SelectedImageKey = "folder_monitor_16.gif";
                                monMake.Tag = new TreeViewTag(make);
                                monMake.Nodes.Add("None");
                            }
                        }
                        break;
                    case TreeViewType.MonitorByType:
                        {
                            var discoveredMonitorTypes = (from m in context.MonitorModels
                                                          where m.Type.HasValue && m.CustomerId == CurrentUser.CustomerId
                                                          select (MonitorType)m.Type.Value).Distinct().ToArray();

                            foreach (var type in discoveredMonitorTypes)
                            {
                                string name = LocalizedEnumConverter.ConvertToString(type);
                                TreeNode monType = e.Node.Nodes.Add(name);
                                monType.TreeView.BeforeExpand += new TreeViewCancelEventHandler(this.treeView1_BeforeExpand);
                                monType.TreeView.AfterSelect += new TreeViewEventHandler(this.treeView1_AfterSelect);
                                monType.ImageKey = "folder_monitor_closed_16.gif";
                                monType.SelectedImageKey = "folder_monitor_16.gif";
                                monType.Tag = new TreeViewTag(type);
                                monType.Nodes.Add("None");
                            }
                        }
                        break;
                    case TreeViewType.MonitorType:
                        {
                            TreeViewTag tag = (TreeViewTag)e.Node.Tag;
                            foreach (var make in (from m in context.MonitorModels
                                                  where m.Type == (int)tag.MonitorType.Value && m.CustomerId == CurrentUser.CustomerId
                                                  select m.MonitorMake).Distinct())
                            {
                                TreeNode monMake = e.Node.Nodes.Add(make.DisplayName);
                                monMake.TreeView.BeforeExpand += new TreeViewCancelEventHandler(this.treeView1_BeforeExpand);
                                monMake.TreeView.AfterSelect += new TreeViewEventHandler(this.treeView1_AfterSelect);
                                monMake.ImageKey = "folder_monitor_closed_16.gif";
                                monMake.SelectedImageKey = "folder_monitor_16.gif";
                                monMake.Tag = new TreeViewTag(make, tag.MonitorType.Value);
                                monMake.Nodes.Add("None");
                            }
                        }
                        break;
                    case TreeViewType.MonitorMake:
                        {
                            TreeViewTag tag = (TreeViewTag)e.Node.Tag;
                            var models = (from m in context.MonitorModels
                                          where m.Manufacturer_Idn == tag.MonitorMake.Make_Idn && m.CustomerId == CurrentUser.CustomerId
                                          select new
                                          {
                                              Model = m,
                                              Num = m.ComputerMonitors.Where(n => n.Detected).Count()
                                          }).Where(n => n.Num > 0).Select(n => n.Model);

                            if (tag.MonitorType.HasValue)
                                models = (from m in context.MonitorModels
                                          where m.Manufacturer_Idn == tag.MonitorMake.Make_Idn
                                                && m.Type == (int)tag.MonitorType.Value && m.CustomerId == CurrentUser.CustomerId
                                          select new
                                          {
                                              Model = m,
                                              Num = m.ComputerMonitors.Where(n => n.Detected).Count()
                                          }).Where(n => n.Num > 0).Select(n => n.Model);

                            foreach (var model in models)
                            {
                                TreeNode monMake = e.Node.Nodes.Add(model.DisplayName);
                                monMake.TreeView.BeforeExpand += new TreeViewCancelEventHandler(this.treeView1_BeforeExpand);
                                monMake.TreeView.AfterSelect += new TreeViewEventHandler(this.treeView1_AfterSelect);
                                monMake.ImageKey = "folder_monitor_closed_16.gif";
                                monMake.SelectedImageKey = "folder_monitor_16.gif";
                                monMake.Tag = new TreeViewTag(model, tag);
                                //monMake.Nodes.Add("None");
                            }
                        }
                        break;
                    case TreeViewType.GlobalDirectory:
                        {
                            foreach (var ad in (from ad in context.ActiveDirectories
                                                join a in context.ActiveDirectoryFolders on ad.ServerName equals a.Name into temp
                                                from a in temp.Where(n => n.ParentFolder_Idn == null).DefaultIfEmpty()
                                                where (a == null || !ad.UseCache.HasValue || (a != null && ad.UseCache.HasValue && !ad.UseCache.Value)) && ad.CustomerId == CurrentUser.CustomerId
                                                select ad))
                            {
                                TreeNode adServer = e.Node.Nodes.Add(ad.ServerName);
                                adServer.TreeView.BeforeExpand += new TreeViewCancelEventHandler(this.treeView1_BeforeExpand);
                                adServer.TreeView.AfterSelect += new TreeViewEventHandler(this.treeView1_AfterSelect);
                                adServer.ImageKey = "server_earth_16.gif";
                                adServer.SelectedImageKey = "server_earth_selected_16.gif";
                                adServer.Tag = new TreeViewTag(ad);
                                adServer.Nodes.Add("None");
                            }

                            foreach (var ad in (from a in context.ActiveDirectoryFolders
                                                join ad in context.ActiveDirectories on a.Name equals ad.ServerName into temp
                                                from ad in temp.DefaultIfEmpty()
                                                where (a.ParentFolder_Idn == null && (ad == null || (ad.UseCache.HasValue && ad.UseCache.Value))) && a.CustomerId == CurrentUser.CustomerId
                                                select a))
                            {
                                TreeNode adServer = e.Node.Nodes.Add(ad.Name);
                                adServer.TreeView.BeforeExpand += new TreeViewCancelEventHandler(this.treeView1_BeforeExpand);
                                adServer.TreeView.AfterSelect += new TreeViewEventHandler(this.treeView1_AfterSelect);
                                adServer.ImageKey = "server_earth_16.gif";
                                adServer.SelectedImageKey = "server_earth_selected_16.gif";
                                adServer.Tag = new TreeViewTag(ad);
                                adServer.Nodes.Add("None");
                            }
                        }
                        break;
                    case TreeViewType.ActiveDirectory:
                        {
                            TreeViewTag tag1 = (TreeViewTag)e.Node.Tag;
                            DirectoryEntry entry = null;
                            if (tag1.ADServer != null)
                            {
                                try
                                {
                                    entry = tag1.ADServer.Entry;
                                    DirectorySearcher dSearch = new DirectorySearcher(entry);
                                    dSearch.Filter = "(|(objectclass=organizationalUnit)(objectclass=container))";
                                    dSearch.SearchScope = SearchScope.OneLevel;

                                    foreach (SearchResult sResultSet in dSearch.FindAll())
                                    {
                                        DirectoryEntry node = sResultSet.GetDirectoryEntry();
                                        TreeNode adOU = e.Node.Nodes.Add(node.Name.Split('=')[1]);
                                        adOU.TreeView.BeforeExpand += new TreeViewCancelEventHandler(this.treeView1_BeforeExpand);
                                        adOU.TreeView.AfterSelect += new TreeViewEventHandler(this.treeView1_AfterSelect);                  
                                        adOU.ImageKey = "folder_16.gif";
                                        adOU.SelectedImageKey = "folder_open_16.gif";
                                        adOU.Tag = new TreeViewTag(node);
                                        adOU.Nodes.Add("None");
                                    }
                                }
                                catch (Exception ex)
                                {

                                    LogWriter.Instance.Error(ex.ToString());
                                    MessageBox.Show(ex.Message, ex.Source);
                                }
                            }
                            else
                            {
                                var subFolders = (from f in context.ActiveDirectoryFolders
                                                  where f.ParentFolder_Idn == tag1.ADFolder.Folder_Idn && f.CustomerId == CurrentUser.CustomerId
                                                  select f);
                                foreach (var res in subFolders)
                                {
                                    TreeNode adOU = e.Node.Nodes.Add(res.Name);
                                    adOU.TreeView.BeforeExpand += new TreeViewCancelEventHandler(this.treeView1_BeforeExpand);
                                    adOU.TreeView.AfterSelect += new TreeViewEventHandler(this.treeView1_AfterSelect);
                                    adOU.ImageKey = "folder_16.gif";
                                    adOU.SelectedImageKey = "folder_open_16.gif";
                                    adOU.Tag = new TreeViewTag(res);
                                    adOU.Nodes.Add("None");
                                }
                            }

                            BuildTreeRoles(e.Node, entry, tag1.ADFolder);
                        }
                        break;
                    case TreeViewType.DirectoryEntry:
                        {
                            TreeViewTag tag2 = (TreeViewTag)e.Node.Tag;
                            if (tag2.Entry != null)
                            {
                                DirectorySearcher dSearch = new DirectorySearcher(tag2.Entry);
                                dSearch.Filter = "(|(objectclass=organizationalUnit)(objectclass=container))";
                                dSearch.SearchRoot = tag2.Entry;
                                dSearch.SearchScope = SearchScope.OneLevel;

                                foreach (SearchResult sResultSet in dSearch.FindAll())
                                {
                                    DirectoryEntry node = sResultSet.GetDirectoryEntry();
                                    TreeNode adOU = e.Node.Nodes.Add(node.Name.Split('=')[1]);
                                    adOU.TreeView.BeforeExpand += new TreeViewCancelEventHandler(this.treeView1_BeforeExpand);
                                    adOU.TreeView.AfterSelect += new TreeViewEventHandler(this.treeView1_AfterSelect);
                                    adOU.ImageKey = "folder_16.gif";
                                    adOU.SelectedImageKey = "folder_open_16.gif";
                                    adOU.Tag = new TreeViewTag(node);
                                    adOU.Nodes.Add("None");
                                }
                            }
                            else
                            {
                                var subFolders = (from s in context.ActiveDirectoryFolders
                                                  where s.ParentFolder_Idn == tag2.ADFolder.Folder_Idn && s.CustomerId == CurrentUser.CustomerId
                                                  select s);
                                foreach (var f in subFolders)
                                {
                                    TreeNode adOU = e.Node.Nodes.Add(f.Name);
                                    adOU.TreeView.BeforeExpand += new TreeViewCancelEventHandler(this.treeView1_BeforeExpand);
                                    adOU.TreeView.AfterSelect += new TreeViewEventHandler(this.treeView1_AfterSelect);
                                    adOU.ImageKey = "folder_16.gif";
                                    adOU.SelectedImageKey = "folder_open_16.gif";
                                    adOU.Tag = new TreeViewTag(f);
                                    adOU.Nodes.Add("None");
                                }
                            }

                            BuildTreeRoles(e.Node, tag2.Entry, tag2.ADFolder);
                        }
                        break;
                    case TreeViewType.GlobalLANDesk:
                        {
                            foreach (LANDeskServer server in context.LANDeskServers.Where(n => n.Type == (int)ManagementServerTypes.LANDesk && n.CustomerId == CurrentUser.CustomerId))
                            {
                                TreeNode publicDevices = e.Node.Nodes.Add(server.CoreServer);
                                publicDevices.TreeView.BeforeExpand += new TreeViewCancelEventHandler(this.treeView1_BeforeExpand);
                                publicDevices.TreeView.AfterSelect += new TreeViewEventHandler(this.treeView1_AfterSelect);
                                publicDevices.ImageKey = "server_16.gif";
                                publicDevices.SelectedImageKey = "server_document_16.gif";
                                publicDevices.Tag = new TreeViewTag(server);
                                publicDevices.Nodes.Add("None");
                            }
                        }
                        break;
                    case TreeViewType.GlobalSCCM:
                        {
                            foreach (LANDeskServer server in context.LANDeskServers.Where(n => n.Type == (int)ManagementServerTypes.SMS && n.CustomerId == CurrentUser.CustomerId))
                            {
                                var smsTreeView = SccmTreeView.BuildTree(e.Node, server, context);
                            }
                        }
                        break;
                    case TreeViewType.LANDeskServer:
                        {
                            TreeViewTag tag2 = (TreeViewTag)e.Node.Tag;
                            LANDeskServer server = tag2.LdmsServer;
                            IDbConnection conn = null;

                            try
                            {
                                conn = server.NewOpen();
                            }
                            catch (Exception ex)
                            {

                                MessageBox.Show(ex.Message, CommonResources.UnableToConnect);
                                return;
                            }
                            IDbCommand cmd = conn.CreateCommand();
                            cmd.CommandText = "SELECT * FROM CustomGroup WHERE ParentCustomGroup_Idn is null AND (Type = 1 OR Type = 0) AND ConsoleUser_Idn = 1 order by name";
                            IDataReader reader = cmd.ExecuteReader();
                            while (reader.Read())
                            {
                                CustomGroup cg = new CustomGroup();
                                cg.Name = reader["Name"] as string;
                                cg.Type = Convert.ToInt32(reader["Type"]);
                                cg.CustomGroup_Idn = Convert.ToInt32(reader["CustomGroup_Idn"]);
                                cg.Server = server;

                                TreeNode publicDevices = e.Node.Nodes.Add(cg.Name);
                                if (cg.Type == 1)
                                {
                                    publicDevices.ImageKey = "folder_data_16.gif";
                                }
                                else
                                {
                                    publicDevices.ImageKey = "folder_computers_16.gif";
                                }
                                publicDevices.Tag = new TreeViewTag(cg);
                                publicDevices.Nodes.Add("None");
                            }
                            reader.Close();

                            conn.Close();
                        }
                        break;
                    case TreeViewType.LANDeskFolder:
                        {
                            TreeViewTag tag2 = (TreeViewTag)e.Node.Tag;
                            CustomGroup cg = tag2.CustomGroup;
                            IDbConnection conn = cg.Server.NewOpen();

                            IDbCommand cmd = conn.CreateCommand();
                            cmd.CommandText = "SELECT * FROM CustomGroup WHERE ParentCustomGroup_Idn = " + cg.CustomGroup_Idn + " order by name";
                            IDataReader reader = cmd.ExecuteReader();
                            while (reader.Read())
                            {
                                CustomGroup cgChild = new CustomGroup();
                                cgChild.Name = reader["Name"] as string;
                                cgChild.Type = Convert.ToInt32(reader["Type"]);
                                cgChild.CustomGroup_Idn = Convert.ToInt32(reader["CustomGroup_Idn"]);
                                cgChild.ParentCustomGroup_Idn = cg.CustomGroup_Idn;
                                cgChild.Server = cg.Server;

                                TreeNode publicDevices = e.Node.Nodes.Add(cgChild.Name);
                                publicDevices.TreeView.BeforeExpand += new TreeViewCancelEventHandler(this.treeView1_BeforeExpand);
                                publicDevices.TreeView.AfterSelect += new TreeViewEventHandler(this.treeView1_AfterSelect);
                                publicDevices.ImageKey = "folder_computers_16.gif";
                                publicDevices.Tag = new TreeViewTag(cgChild);
                                publicDevices.Nodes.Add("None");
                            }
                            reader.Close();

                            if (cg.Type == 1)
                            {
                                cmd.CommandText = "select * from query where query_idn in (select member_idn FROM customgroupquery where customgroup_idn = " + cg.CustomGroup_Idn + ") order by name";
                                reader = cmd.ExecuteReader();
                                while (reader.Read())
                                {
                                    int LANDeskQueryID = Convert.ToInt32(reader["Query_Idn"]);
                                    int LANDeskServerID = cg.Server.Server_Idn;
                                    string LANDeskQueryName = reader["Name"] as string;

                                    //save the query info into the database (if it doesn't exist) so we 
                                    //can re-query without the treeview (data/view separation FTW)
                                    var ldmsquery = (from q in context.Queries
                                                     where q.ExternalID == LANDeskQueryID && q.CustomerId == CurrentUser.CustomerId
                                                     select q).FirstOrDefault();
                                    if (ldmsquery == null)
                                    {
                                        ldmsquery = new VERISMIC.Database.PowerManager.Query();
                                        ldmsquery.ExternalID = LANDeskQueryID;
                                        ldmsquery.CustomerId = CurrentUser.CustomerId;
                                        context.Queries.InsertOnSubmit(ldmsquery);
                                    }
                                    ldmsquery.Name = LANDeskQueryName;
                                    ldmsquery.Description = @"";
                                    ldmsquery.Server_Idn = LANDeskServerID;
                                    ldmsquery.QuerySQL = @""; //don't care for this anymore
                                    ldmsquery.QueryType = (int)QueryTypes.LANDeskQuery;

                                    if (ldmsquery.Priority == null)
                                        ldmsquery.Priority = context.Queries.Where(n => n.QueryType == (int)QueryTypes.LANDeskQuery && n.CustomerId == CurrentUser.CustomerId).Max(n => n.Priority) + 1;

                                    context.SubmitChanges();

                                    context.ClearCache();

                                    TreeNode publicDevices = e.Node.Nodes.Add(ldmsquery.Name);
                                    publicDevices.TreeView.BeforeExpand += new TreeViewCancelEventHandler(this.treeView1_BeforeExpand);
                                    publicDevices.TreeView.AfterSelect += new TreeViewEventHandler(this.treeView1_AfterSelect);
                                    publicDevices.ImageKey = "data_find.gif";
                                    publicDevices.Tag = new TreeViewTag(ldmsquery, QueryTypes.LANDeskQuery);

                                }
                                reader.Close();
                            }

                            conn.Close();
                        }
                        break;
                    case TreeViewType.QueriesFolder:
                    case TreeViewType.GlobalQueries:
                        BuildTreeQueries(e.Node);
                        break;
                    case TreeViewType.GroupsFolder:
                    case TreeViewType.Groups:
                        BuildTreeGroups(e.Node);
                        break;
                }
                e.Node.Collapse();
                e.Node.Expand();
            }
        }

        private void BuildTreeQueries(TreeNode parent)
        {
            int? parentTagId = null;
            if (parent.Tag != null)
            {
                var tag = parent.Tag as TreeViewTag;
                if (tag.QueriesFolder != null)
                {
                    parentTagId = tag.QueriesFolder.ID;
                }
            }

            var queries = queriesAndFoldersManager.GetQueries(parentTagId);

            foreach (var query in queries)
            {
                string name = query.Name;
                if (query.Location_Idn != null)
                {
                    name += " (" + query.Location.LocationName + ")";
                }
                TreeNode queriesNode = parent.Nodes.Add(name);
                queriesNode.TreeView.BeforeExpand += new TreeViewCancelEventHandler(this.treeView1_BeforeExpand);
                queriesNode.TreeView.AfterSelect += new TreeViewEventHandler(this.treeView1_AfterSelect);
                queriesNode.ImageKey = "dbqueryopen_16.gif";
                queriesNode.Tag = new TreeViewTag(query, QueryTypes.VerismicQuery, parent.Tag as TreeViewTag);
            }

            var queriesFodlers = queriesAndFoldersManager.GetFolders(parentTagId, CurrentUser.CustomerId);

            foreach (var queriesFodler in queriesFodlers)
            {
                TreeNode treeNode = parent.Nodes.Add(queriesFodler.Name);
                treeNode.TreeView.BeforeExpand += new TreeViewCancelEventHandler(this.treeView1_BeforeExpand);
                treeNode.TreeView.AfterSelect += new TreeViewEventHandler(this.treeView1_AfterSelect);
                treeNode.ImageKey = "files_16.gif";
                treeNode.Tag = new TreeViewTag(queriesFodler);
                treeNode.Nodes.Add("None");
            }
        }

        private void BuildTreeGroups(TreeNode parent)
        {
            int? parentTagId = null;
            if (parent.Tag != null)
            {
                var tag = parent.Tag as TreeViewTag;
                if (tag.GroupsFolder != null)
                {
                    parentTagId = tag.GroupsFolder.ID;
                }
            }

            var groups = groupsAndFoldersManager.GetGroups(parentTagId, CurrentUser.CustomerId);

            foreach (var group in groups)
            {
                TreeNode treeNode = parent.Nodes.Add(group.Name);
                treeNode.TreeView.BeforeExpand += new TreeViewCancelEventHandler(this.treeView1_BeforeExpand);
                treeNode.TreeView.AfterSelect += new TreeViewEventHandler(this.treeView1_AfterSelect);
                treeNode.ImageKey = "files_16.gif";
                treeNode.Tag = new TreeViewTag(group, parent.Tag as TreeViewTag);
            }

            var groupsFolders = groupsAndFoldersManager.GetFolders(parentTagId, CurrentUser.CustomerId);

            foreach (var groupsFolder in groupsFolders)
            {
                TreeNode treeNode = parent.Nodes.Add(groupsFolder.Name);
                treeNode.TreeView.BeforeExpand += new TreeViewCancelEventHandler(this.treeView1_BeforeExpand);
                treeNode.TreeView.AfterSelect += new TreeViewEventHandler(this.treeView1_AfterSelect);
                treeNode.ImageKey = "files_16.gif";
                treeNode.Tag = new TreeViewTag(groupsFolder);
                treeNode.Nodes.Add("None");
            }
        }

        private void BuildTreeRoles(TreeNode parent, Location loc)
        {
            if (!this.ViewType.HasFlag(AccessViewTypes.Roles))
                return;

            TreeNode node = parent.Nodes.Add(CommonResources.All);
            node.TreeView.BeforeExpand += new TreeViewCancelEventHandler(this.treeView1_BeforeExpand);
            node.TreeView.AfterSelect += new TreeViewEventHandler(this.treeView1_AfterSelect);
            node.ImageKey = "cpu_16.gif";
            node.Tag = new TreeViewTag(TreeViewType.All);

            var roles = (from c in context.Computers
                         where c.Location.Path.EndsWith(loc.Path) && c.CustomerId == CurrentUser.CustomerId
                         orderby c.SystemRole_Idn
                         select (SystemRoles)c.SystemRole_Idn).Distinct();

            foreach (var role in roles)
            {
                TreeNode treeRole = node.Nodes.Add(role.ToString());
                treeRole.TreeView.BeforeExpand += new TreeViewCancelEventHandler(this.treeView1_BeforeExpand);
                treeRole.TreeView.AfterSelect += new TreeViewEventHandler(this.treeView1_AfterSelect);
                treeRole.ImageKey = "cpu_16.gif";
                treeRole.Nodes.Add("None");
                treeRole.Tag = new TreeViewTag(role, node.Tag as TreeViewTag);
            }

            var chassisTypes = (from c in context.Computers
                                where c.Location.Path.EndsWith(loc.Path) && c.CustomerId == CurrentUser.CustomerId
                                select (ChassisTypes)c.ChassisType_Idn).Distinct();

            foreach (var type in chassisTypes)
            {
                TreeNode treeType = parent.Nodes.Add(type.ToString());
                treeType.TreeView.BeforeExpand += new TreeViewCancelEventHandler(this.treeView1_BeforeExpand);
                treeType.TreeView.AfterSelect += new TreeViewEventHandler(this.treeView1_AfterSelect);
                treeType.ImageKey = "cpu_16.gif";
                treeType.Tag = new TreeViewTag(type, parent.Tag as TreeViewTag);

                foreach (var role in roles)
                {
                    TreeNode treeRole = treeType.Nodes.Add(role.ToString());
                    treeRole.TreeView.BeforeExpand += new TreeViewCancelEventHandler(this.treeView1_BeforeExpand);
                    treeRole.TreeView.AfterSelect += new TreeViewEventHandler(this.treeView1_AfterSelect);
                    treeRole.ImageKey = "cpu_16.gif";
                    treeRole.Nodes.Add("None");
                    treeRole.Tag = new TreeViewTag(role, treeType.Tag as TreeViewTag);
                }
            }
        }

        private void BuildTreeRoles(TreeNode parent, DirectoryEntry entry, ActiveDirectoryFolder folder)
        {
            TreeNode node = parent.Nodes.Add(CommonResources.All);
            node.TreeView.BeforeExpand += new TreeViewCancelEventHandler(this.treeView1_BeforeExpand);
            node.TreeView.AfterSelect += new TreeViewEventHandler(this.treeView1_AfterSelect);
            node.ImageKey = "cpu_16.gif";
            node.Tag = new TreeViewTag(TreeViewType.All);

            string path = null;

            if (entry != null)
            {
                path = GetEntryPath(entry);
            }
            else
            {
                path = folder.Path;
            }

            if (string.IsNullOrEmpty(path))
                return;

            var roles = (from c in context.Computers
                         where c.MachineOU.EndsWith(path) && c.CustomerId == CurrentUser.CustomerId
                         orderby c.SystemRole_Idn
                         select (SystemRoles)c.SystemRole_Idn).Distinct();

            foreach (var role in roles)
            {
                TreeNode treeRole = node.Nodes.Add(role.ToString());
                treeRole.TreeView.BeforeExpand += new TreeViewCancelEventHandler(this.treeView1_BeforeExpand);
                treeRole.TreeView.AfterSelect += new TreeViewEventHandler(this.treeView1_AfterSelect);
                treeRole.ImageKey = "cpu_16.gif";
                treeRole.Nodes.Add("None");
                treeRole.Tag = new TreeViewTag(role, node.Tag as TreeViewTag);
            }

            var chassisTypes = (from c in context.Computers
                                where c.MachineOU.EndsWith(path) && c.CustomerId == CurrentUser.CustomerId
                                select (ChassisTypes)c.ChassisType_Idn).Distinct();
            foreach (var type in chassisTypes)
            {
                TreeNode treeType = parent.Nodes.Add(type.ToString());
                treeType.ImageKey = "cpu_16.gif";
                treeType.Tag = new TreeViewTag(type, parent.Tag as TreeViewTag);

                foreach (var role in roles)
                {
                    TreeNode treeRole = treeType.Nodes.Add(role.ToString());
                    treeRole.ImageKey = "cpu_16.gif";
                    treeRole.Nodes.Add("None");
                    treeRole.Tag = new TreeViewTag(role, treeType.Tag as TreeViewTag);
                }
            }
        }

        private void BuildTreeRoles(TreeNode parent)
        {
            TreeNode node = parent.Nodes.Add(CommonResources.All);
            node.TreeView.BeforeExpand += new TreeViewCancelEventHandler(this.treeView1_BeforeExpand);
            node.TreeView.AfterSelect += new TreeViewEventHandler(this.treeView1_AfterSelect);
            node.ImageKey = "cpu_16.gif";
            node.Tag = new TreeViewTag(TreeViewType.All);

            var roles = (from c in context.Computers
                         where c.CustomerId == CurrentUser.CustomerId
                         orderby c.SystemRole_Idn
                         select (SystemRoles)c.SystemRole_Idn).Distinct();

            foreach (var role in roles)
            {
                TreeNode treeRole = node.Nodes.Add(role.ToString());
                treeRole.TreeView.BeforeExpand += new TreeViewCancelEventHandler(this.treeView1_BeforeExpand);
                treeRole.TreeView.AfterSelect += new TreeViewEventHandler(this.treeView1_AfterSelect);
                treeRole.ImageKey = "cpu_16.gif";
                treeRole.Nodes.Add("None");
                treeRole.Tag = new TreeViewTag(role, node.Tag as TreeViewTag);
            }

            var chassisTypes = (from c in context.Computers
                                where c.CustomerId == CurrentUser.CustomerId
                                select (ChassisTypes)c.ChassisType_Idn).Distinct();
            foreach (ChassisTypes type in chassisTypes)
            {
                TreeNode treeType = parent.Nodes.Add(type.ToString());
                treeType.TreeView.BeforeExpand += new TreeViewCancelEventHandler(this.treeView1_BeforeExpand);
                treeType.TreeView.AfterSelect += new TreeViewEventHandler(this.treeView1_AfterSelect);
                treeType.ImageKey = "cpu_16.gif";
                treeType.Tag = new TreeViewTag(type, parent.Tag as TreeViewTag);

                foreach (var role in roles)
                {
                    TreeNode treeRole = treeType.Nodes.Add(role.ToString());
                    treeRole.TreeView.BeforeExpand += new TreeViewCancelEventHandler(this.treeView1_BeforeExpand);
                    treeRole.TreeView.AfterSelect += new TreeViewEventHandler(this.treeView1_AfterSelect);
                    treeRole.ImageKey = "cpu_16.gif";
                    treeRole.Nodes.Add("None");
                    treeRole.Tag = new TreeViewTag(role, treeType.Tag as TreeViewTag);
                }
            }
        }

        private void BuildTreeManufacturers(TreeNode parent, SystemRoles? role)
        {
            var computers = GetComputerQuery(parent);

            var manfacturers = (from c in computers
                                from m in context.Manufacturers
                                where c.SystemRole_Idn == (int)role
                                && m.Make_Idn == c.Manufacturer_Idn && c.CustomerId == CurrentUser.CustomerId && m.CustomerId == CurrentUser.CustomerId
                                orderby m.DisplayName
                                select m).Distinct();

            foreach (var manfacturer in manfacturers)
            {
                TreeNode treeManu = parent.Nodes.Add(manfacturer.Name);
                treeManu.TreeView.BeforeExpand += new TreeViewCancelEventHandler(this.treeView1_BeforeExpand);
                treeManu.TreeView.AfterSelect += new TreeViewEventHandler(this.treeView1_AfterSelect);
                treeManu.ImageKey = "files_16.gif";
                treeManu.Tag = new TreeViewTag(manfacturer, parent.Tag as TreeViewTag);
                treeManu.Nodes.Add("None");
            }
        }

        private void BuildTreeModels(TreeNode parent)
        {
            try
            {
                var computers = GetComputerQuery(parent);

                var models = (from c in computers
                              orderby c.Model.DisplayName
                              select c.Model).Distinct();

                foreach (var model in models)
                {
                    TreeNode treeModal = parent.Nodes.Add(model.Name);
                    treeModal.TreeView.BeforeExpand += new TreeViewCancelEventHandler(this.treeView1_BeforeExpand);
                    treeModal.TreeView.AfterSelect += new TreeViewEventHandler(this.treeView1_AfterSelect);
                    treeModal.ImageKey = "document_16.gif";
                    treeModal.Tag = new TreeViewTag(model, parent.Tag as TreeViewTag);
                }
            }
            catch (Exception ex)
            {
                LogWriter.Instance.Error(ex.ToString());
                throw;
            }
        }

        private void BuildTreeMonitorModels(TreeNode parent)
        {
            var make = (parent.Tag as TreeViewTag).MonitorMake;
            var models = (from c in context.MonitorModels
                          where c.MonitorMake == make && c.CustomerId == CurrentUser.CustomerId
                          orderby c.MonitorMake.DisplayName
                          select c);
            foreach (var model in models)
            {
                TreeNode treeModal = parent.Nodes.Add(model.Name);
                treeModal.TreeView.BeforeExpand += new TreeViewCancelEventHandler(this.treeView1_BeforeExpand);
                treeModal.TreeView.AfterSelect += new TreeViewEventHandler(this.treeView1_AfterSelect);
                treeModal.ImageKey = "document_16.gif";
                treeModal.Tag = new TreeViewTag(model, parent.Tag as TreeViewTag);
            }
        }
        
        public bool HasNode(TreeNode node)
        {
            if (treeView1.Nodes.Count == 0)
            {
                CollectionBrowser_Load(null, null);
            }

            return FindRecourcieveNode(treeView1.Nodes, node);
        }

        private bool FindRecourcieveNode(TreeNodeCollection nodes, TreeNode node)
        {
            foreach (TreeNode innderNode in nodes.Cast<TreeNode>())
            {
                innderNode.Collapse();
                innderNode.Expand();
                if (node.FullPath == innderNode.FullPath || FindRecourcieveNode(innderNode.Nodes, node)) return true;
            }
            return false;
        }
    }

    //[Flags]
    //public enum AccessViewTypes
    //{
    //    GlobalSiteView = 1,
    //    Computers = 2,
    //    Queries = 4,
    //    Makes = 8,
    //    Models = 16,
    //    ActiveDirectory = 32,
    //    SystemsManagment = 64,
    //    Monitors = 128,
    //    Roles = 256,
    //    Groups = 512,
    //    All = GlobalSiteView | Computers | Queries | Makes | Models | ActiveDirectory | SystemsManagment | Monitors | Roles | Groups
    //}
}

